#!/usr/bin/env python3

l = 4
n = 2 ** (l - 1)
nodes = [2 * i for i in range(n)]

def cdraw(cs):
    m = max(cs)
    for i in range(m + 1):
        print('*' if i in cs else ' ', end='')
    print()

def closer(cs):
    i = 0
    m = []
    while i < len(cs):
        j = i + 1
        a, b = cs[i] + 1, cs[j] - 1
        m.append(a)
        if a < b:
            m.append(b)
        i += 2
    return m

def r(cs):
    if len(cs) > 1:
        r(closer(cs))
    cdraw(cs)

if __name__ == "__main__":
    r(nodes)
